<template>
  <ObTable
    class="order-subtype-table"
    :items="items"
    :columns="columns"
    :selected="{}"
    :functional-panel="false"
    data-qa="selectOrderSubTypeTable"
  >
    <div slot="gosNumber" slot-scope="{ data }">
      <div v-html="gosNumberHtml(data.item)" />
    </div>
    <div slot="status" slot-scope="{ data }">
      <div class="cell-status">
        <div :style="{ color: statusColors[data.item.status]}">{{ data.item.status }}</div>
        <ObButton
          label="Назначить"
          :mini="true"
          data-qa="btnAppoint"
          @click="selectExecutor(data)"
        />
      </div>
    </div>
  </ObTable>
</template>

<script>
import ObTable from 'common-components/src/obComponents/obTable'
import ObButton from 'common-components/src/obComponents/obButton'
import moment from 'moment'
import { subTypeItems } from '@/resources/order'

export default {
  components: {
    ObTable,
    ObButton
  },
  data () {
    return {
      statusColors: {
        'Доступен': '#10CF96',
        'Нет данных': '#9DA0AC'
      }
    }
  },
  computed: {
    columns() {
      return [
        {
          title: 'Регистрационный номер',
          key: 'gos_number',
          slotName: 'gosNumber',
          width: 140,
        },
        {
          title: `Группа риска`,
          key: 'icon',
          width: 80,
          html: (data) => `<i class="icon ${data.icon}" style="font-size: 22px;"></i>`
        },
        {
          title: 'Марка',
          key: 'modelAuto'
        },
        {
          title: 'Год выпуска',
          key: 'year',
          width: 90
        },
        {
          title: 'Выполнено рейсов',
          key: 'count',
          width: 110,
          html: (data) => data.count || '-'
        },
        {
          title: 'Право владения',
          key: 'pravo',
          width: 150
        },
        {
          title: 'Регистрация',
          key: 'reg',
          html: (data) => this.getHtmlDatetime(data.reg)
        },
        {
          title: 'статус',
          key: 'status',
          width: 150,
          slotName: 'status'
        }
      ];
    },
    items() {
      return subTypeItems
    },
  },
  methods: {
    selectExecutor (data) {
      this.$emit('on-select', data.item)
    },
    gosNumberHtml (data) {
      return `<div class="gos-number">
                <span class="block">${data.grzNum}</span>
                <span class="block">${data.grzReg}</span>
              </div>`
    },
    statusHtml (data) {
      return `<div class="gos-number">
                <span class="block">${data.grzNum}</span>
                <span class="block">${data.grzReg}</span>
              </div>`
    },
    getHtmlDatetime(datetime, isTime = true) {
      return datetime ? `
        <div class="field-datetime">
          <div>${moment(datetime).locale('ru').format('L')}</div>
          <div class="field-time ${isTime ? '' : 'hidden'}">${moment(datetime).locale('ru').format('LT')}</div>
        </div>
      ` : ''
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.order-subtype-table {
  &::v-deep {
    &:before {
      display: none !important;
    }
    table {
      min-width: auto!important;
      table-layout: auto!important;
    }
    .table-panel-inner {
      border-left: 1px solid $lavender;
      border-right: 1px solid $lavender;
      border-radius: 3px;
    }
    .table-footer {
      display: none;
    }
    .tariff-cell {
      @include font-mixin(14px, 18px, 600, $color-text-base, 0.2px);
    }

    th {
      .td-container {
        word-break: break-word;
      }
    }

    td {
      .td-container {
        min-height: 75px!important;
      }
    }

    .cell-status {
      button {
        display: none;
      }
    }

    tr:hover {
      .cell-status {
        & > div {
          display: none;
        }
        button {
          display: block;
        }
      }
    }


    .field-datetime {
      @include font-mixin(14px, 20px, 400);

      .field-time {
        color: $color-grey-span;
        &.hidden {
          display: none;
        }
      }
    }
  }
}

.max-width-100 {
  max-width: 100%;
}

.color-red {
  color: $light-raspberry-red;
}

.color-green {
  color: $color-green-light;
}

.color-gray {
  color: $color-grey-span;
}

.text-small {
  font-size: 12px;
  line-height: 20px;
}

.text-right {
  text-align: right;
}
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

</style>
